//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
// declarations from the Rich Edit 3.0 Code Samples page
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>

class TRichEdit30 : public TRichEdit
{
private:
  int FLibHandle;

protected:
  virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
  virtual void __fastcall DestroyWnd(void);
  virtual void __fastcall CreateWnd(void);
  virtual void __fastcall WndProc(Messages::TMessage &Message);

public:
  __fastcall TRichEdit30(TComponent* Owner);
  __fastcall ~TRichEdit30();
  virtual void __fastcall RecreateWnd(void);      // not virtual in base!!!
};
//---------------------------------------------------------------------------
// definitions from the Rich Edit 3.0 Code Samples page
//---------------------------------------------------------------------------
// may need to add code here later
//
__fastcall TRichEdit30::TRichEdit30(TComponent* Owner) : TRichEdit(Owner)
{
}
//---------------------------------------------------------------------------
// may need to add code here later
//
__fastcall TRichEdit30::~TRichEdit30()
{
}
//---------------------------------------------------------------------------
// may need to add code here later
//
void __fastcall TRichEdit30::CreateWnd(void)
{
  TRichEdit::CreateWnd();
}
//---------------------------------------------------------------------------
// the following ensures that the riched20.dll (v2.0 or v3.0) is loaded;
// TRichEdit unloads the DLL that *IT* loads in the WM_NCDESTROY handler (which,
// disappointingly enough, is private rather than protected; damned if FLibHandle
// isn't also, or we could simply unload it later) but we do it in DestroyWnd()...
// (note:  do not call TRichEdit::CreateParams -- it will attempt to
// load the older version of the rich edit DLL -- not a Good Thing -- too bad
// if anything important goes on there)
//
void __fastcall TRichEdit30::CreateParams(Controls::TCreateParams &Params)
{
  const char RichEditModuleName[] = "RICHED20.DLL";
  long int OldError;

  OldError = SetErrorMode(SEM_NOOPENFILEERRORBOX);
  FLibHandle = (int) LoadLibrary(RichEditModuleName);
  if (FLibHandle < HINSTANCE_ERROR) FLibHandle = 0;
  SetErrorMode(OldError);
//  TRichEdit::CreateParams(Params);
  TCustomMemo::CreateParams(Params);
//  CreateSubClass(Params, "RICHEDIT");
  CreateSubClass(Params, RICHEDIT_CLASS);
  Params.Style = Params.Style |
	(HideScrollBars ? 0 : ES_DISABLENOSCROLL) | (HideSelection ? 0 : ES_NOHIDESEL);
}
//---------------------------------------------------------------------------
// free the library on destroy (actually, it will not unload until last
// TRichEdit20 instance is destroyed)
//
void __fastcall TRichEdit30::DestroyWnd(void)
{
  TRichEdit::DestroyWnd();
  if (FLibHandle != 0) FreeLibrary((void*) FLibHandle);
}
//---------------------------------------------------------------------------
// may need to add code here later
//
void __fastcall TRichEdit30::WndProc(Messages::TMessage &Message)
{
  TRichEdit::WndProc(Message);
}
//---------------------------------------------------------------------------
// may need to add code here later
//
void __fastcall TRichEdit30::RecreateWnd(void)  // not virtual in base!!!
{
  TRichEdit::RecreateWnd();
}
//---------------------------------------------------------------------------
// global variable required for the Rich Edit 3.0 class
TRichEdit30* RE30;
//---------------------------------------------------------------------------
// code generated by form creation, unless otherwise indicated
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	// code added per the Rich Edit 3.0 Code Samples page
	RE30 = new TRichEdit30(this);
	RE30->Parent = this;
	RE30->Align = alClient;
}
//---------------------------------------------------------------------------
